package domain;

import java.util.ArrayList;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonSubTypes.Type;
import com.fasterxml.jackson.annotation.JsonTypeInfo;

@JsonTypeInfo(use=JsonTypeInfo.Id.NAME, include=JsonTypeInfo.As.PROPERTY, property = "type")
@JsonSubTypes({
	@Type(name = PreScript.TYPE, value = PreScript.class),
	@Type(name = BlankLine.TYPE, value = BlankLine.class),
	@Type(name = NewScene.TYPE, value = NewScene.class),
    @Type(name = Dialogue.TYPE, value = Dialogue.class),
    @Type(name = Action.TYPE, value = Action.class),
    @Type(name = Transition.TYPE, value = Transition.class),
    @Type(name = ShotChange.TYPE, value = ShotChange.class)
})
public abstract class SceneObject {

	int scriptLine;
	@JsonIgnore
	Integer scene;
	@JsonIgnore
	Integer index;

	public int getScriptLine() {
		return scriptLine;
	}

	public void setScriptLine(int scriptLine) {
		this.scriptLine = scriptLine;
	}
	
	public Integer getScene() {
		return scene;
	}

	public void setScene(Integer scene) {
		this.scene = scene;
	}

	public Integer getIndex() {
		return index;
	}

	public void setIndex(Integer index) {
		this.index = index;
	}
	
	@JsonIgnore
	public abstract String getType();
	
}
