package domain;

import java.util.ArrayList;

public enum SceneObjectType {
	preScript("pre script"),
	blankLine("blank line"),
	newScene("new scene"),
	action("action block"),
	dialogue("dialogue"),
	shotChange("shot change"),
	transition("transition");
	
	private final String name;       

    private SceneObjectType(String s) {
        name = s;
    }
    
    public String getName() {
    	return name;
    }
    
    public static ArrayList<String> getStrings() {
    	ArrayList<String> v = new ArrayList<String>();
    	for (SceneObjectType s: SceneObjectType.values()) {
    		v.add(s.getName());
    	}
    	return v;
    }
    

    public static SceneObjectType fromString(String text) {
      if (text != null) {
        for (SceneObjectType t : SceneObjectType.values()) {
          if (text.equalsIgnoreCase(t.name)) {
            return t;
          }
        }
      }
      return null;
    }
}
