package domain;

import java.util.ArrayList;

import parser.Parser;

import com.fasterxml.jackson.annotation.JsonIgnore;

import util.Util;

public class Script {
	String title;
	String fileName;
	
	int year;
	boolean color;
	Genre genre;
	
//	@JsonIgnore
	ArrayList<Scene> scenes;
	
	ArrayList<ScriptObject> objects;
	SceneObjectList sceneObjects;
	int scriptLength;
	Integer[] lines;
	
	public Script(String name, int scriptLength) {
		title="";
		fileName = name;
		scenes = new ArrayList<Scene>();
		objects = new ArrayList<ScriptObject>();
		sceneObjects = new SceneObjectList();
		this.scriptLength = scriptLength;
		lines = new Integer[scriptLength];
	}
	
	public Script() {
	}
	
	public String getTitle() {
		return title;
	}
	public void setTitle(String name) {
		this.title = name;
	}
	
	
	
	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

	public boolean isColor() {
		return color;
	}

	public void setColor(boolean color) {
		this.color = color;
	}

	public Genre getGenre() {
		return genre;
	}

	public void setGenre(Genre genre) {
		this.genre = genre;
	}

	public ArrayList<Scene> getScenes() {
		return scenes;
	}
	public void setScenes(ArrayList<Scene> scenes) {
		this.scenes = scenes;
	}
	public ArrayList<ScriptObject> getObjects() {
		return objects;
	}
	public void setObjects(ArrayList<ScriptObject> objects) {
		this.objects = objects;
	}
	public ScriptObject addObject(String name, int scene) {
		if (objects.size() > 0) {
			for (ScriptObject c:objects)
				if (Util.strippedDown(c.getName())
						.equals(Util.strippedDown(name))) {
					if (!c.getName().equals(name)) {
						String shortest = c.getName();
						if (name.length() < shortest.length())
							shortest = name;
						c.setName(shortest);
					}
					c.addScene(scene);
					return c;
				}
		}
		ScriptObject object = new ScriptObject(Util.clean(name), objects.size());
		object.getScenes().add(scene);
		if (Parser.isGroup(object, objects))
			object.setType(ScriptObjectType.CharGroup);
		if (Parser.isCamera(object))
			object.setType(ScriptObjectType.Camera);
		objects.add(object);
		return object;
	}
	
	public ScriptObject getObject(Integer index) {
		return objects.get(index);
	}
	
	public Integer addSceneObject(SceneObject s, Integer scene) {
		Integer index = sceneObjects.size();
		s.setIndex(index);
		s.setScene(scene);
		sceneObjects.add(s);
		return index;
	}

	public SceneObjectList getSceneObjects() {
		return sceneObjects;
	}

	public void setSceneObjects(SceneObjectList sceneObjects) {
		this.sceneObjects = sceneObjects;
	}

	public int getScriptLength() {
		return scriptLength;
	}

	public Integer[] getLines() {
		return lines;
	}

	public void setLines(Integer[] lines) {
		this.lines = lines;
	}
	
	public void addLine(int index, Integer sceneObject) {
		lines[index] = sceneObject;
	}
	
}
