package domain;

import java.util.ArrayList;

public enum ScriptObjectType {
	Unknown ("The default. Object unknown"),
	Ignore ("Ignore this option. Won't appear in the line tool."),
	Repeat ("A repeat of another script object. Won't appear in the line tool."),
	Character ("A character in the script."),
	Prop ("A prop in the script. Something characters interact with."),
	Sound ("A sound such as an explosion."),
	Action ("An action that happens in the script."),
	Scenery ("A background item in the script characters don't interact with."),
	Camera ("Describes how the camera is shooting the scene. Won't appear in the line tool."),
	CharGroup ("A group of characters. Won't appear in the line tool."),
	Other ("Something not listed above.");
	
	private final String name;       

    private ScriptObjectType(String s) {
        name = s;
    }
    
    public String getName() {
    	return name;
    }
    
    public static ArrayList<String> getStrings() {
    	ArrayList<String> v = new ArrayList<String>();
    	for (ScriptObjectType s: ScriptObjectType.values()) {
    		v.add(s.getName());
    	}
    	return v;
    }
}
